/************************************************************************
 *	Read COPYRIGHT file in this directory				*
 ************************************************************************/


struct { int s; } AG_spinlock;


static inline void AG_spinlock_init
(void)
{
        AG_spinlock.s = 0;
        return;
}


static inline void AG_spinlock_take
(void)
{

        int oldval;


        for (;;) {
                while (AG_spinlock.s);
                asm (
                        "lock; xchgl %0,%1"
                        : "=q" (oldval), "=m" (AG_spinlock.s)
                        : "0" (1)
                        : "memory"
                );
                if (!oldval)
                        break;
        }
        return;
}


static inline void AG_spinlock_release
(void)
{
        AG_spinlock.s = 0;
        return;
}
