/************************************************************************
 *	Read COPYRIGHT file in this directory				*
 ************************************************************************/

#ifndef CHCONFIG
#define CHCONFIG

/*  This implementation is for Intel CPUs only.  */
#undef MPID_HAS_HETERO

/* This makes chbrndv.c use memcpy for rendezvous messages to self */
#define MPID_RNDV_SELF

/* Turn off flow control */
#undef MPID_FLOW_CONTROL

#undef MPID_HAS_PROC_INFO
/* This is needed if you want TotalView to acquire all of the processes
 * automagically.
 * If it is defined you must also define 
 *      int MPID_getpid(int index, char **hostname, char **imagename);
 * which takes an index in COMM_WORLD and returns the pid of that process as a result,
 * and also fills in the pointers to the two strings hostname (something which we can
 * pass to inet_addr, and image_name which is the name of the executable running
 * that this process is running.
 * You can fill in either (or both) pointers as (char *)0 which means
 * "the same as the master process".
 */

/* Communicator initialization routines */
/* Comm_msgrep determines the common representation format for 
   members of the new communicator */
#define MPID_CommInit(oldcomm,newcomm) MPI_SUCCESS
#define MPID_CommFree(comm)            MPI_SUCCESS

#endif
